<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html" xmlns:f="http://java.sun.com/jsf/core"
	xmlns:ship="http://xmlns.jcp.org/jsf/composite/ship" xmlns:p="http://primefaces.org/ui">
<h:head></h:head>
<h:body>
	<ui:composition template="/pages/pridiatemplate.xhtml">
		<ui:define name="body">
			<p:panel header="#{facesContext.translate('label.statistic.welcome.title')}">
				<p:staticMessage severity="info" summary="#{facesContext.translate('label.hint')}" detail="#{facesContext.translate('label.statistic.listfunctions.description')}" />
				<p:dataTable id="datamodel" value="#{statisticModel.dataModel}" var="f" resizableColumns="true" paginator="true" rows="10">
					<p:column headerText="#{facesContext.translate('label.name')}" filterable="true" filterMatchMode="contains" filterBy="#{f.name}" sortBy="#{f.name}" sortable="true"
					          styleClass="column-name" >
						<h:outputText value="#{f.name}" />
					</p:column>
					<p:column headerText="#{facesContext.translate('label.title')}" filterable="true" filterMatchMode="contains" filterBy="#{f.summary}" sortBy="#{f.summary}" sortable="true"
					          styleClass="column-description">
						<h:outputText value="#{f.summary}" />
					</p:column>
					<p:column headerText="#{facesContext.translate('label.statistic.functionusage')}" sortBy="#{f.activated}" sortable="true" styleClass="oneiconbutton" style="text-align: center">
						<i class="pi pi-#{f.activated ? 'check-circle' : 'times-circle'} #{f.activated ? 'greenfont' : 'redfont'}" style="font-size: x-large"
							title="#{facesContext.translate(f.activated ? 'label.active' : 'label.inactive')}"></i>
					</p:column>
					<p:column headerText="#{facesContext.translate('label.statistic.category')}"
					          styleClass="column-name"> <!-- may be wrapped, most frequently, we will have only one category -->
						<ui:repeat id="category" value="#{f.category}" var="cat">
							<h:outputText value="#{cat.name}" title="#{cat.description}" styleClass="squarebadge" />
						</ui:repeat>
					</p:column>
					<p:column headerText="#{facesContext.translate('label.created')}" filterable="true" filterMatchMode="contains" filterBy="#{f.creationdate}" sortBy="#{f.creationdate}" sortable="true"
						styleClass="column-date" >
						<h:outputText value="#{f.creationdate}">
							<f:convertDateTime pattern="yyyy-MM-dd" /> <!-- TODO: Shouldn't the time format follow the chosen language? -->
						</h:outputText>
					</p:column>
					<p:column headerText="#{facesContext.translate('label.lastchange')}" filterable="true" filterMatchMode="contains" filterBy="#{f.lastchange}" sortBy="#{f.lastchange}" sortable="true"
						styleClass="column-datetime" >
						<h:outputText value="#{f.lastchange}">
							<f:convertDateTime pattern="yyyy-MM-dd HH:mm:ss" /> <!-- TODO: Shouldn't the time format follow the chosen language? -->
						</h:outputText>
					</p:column>
					<p:column headerText="#{facesContext.translate('label.actions')}" styleClass="column-six-buttons">
						<ship:buttongroup>
							<p:commandButton id="btn_show" action="#{statisticController.toShow(f)}" value="" icon="fa fa-info-circle" title="#{facesContext.translate('button.show')}"
								disabled="#{!profile.hasPrivilege('statisticadmin') and !f.acl.read and !f.isCreator(facesContext)}" ajax="false" styleClass="iconbutton" />
							<p:commandButton id="btn_edit" action="#{statisticController.toEdit(f.functionId)}" value="" icon="fa fa-pencil" title="#{facesContext.translate('button.edit')}"
								disabled="#{f.activated or (!profile.hasPrivilege('statisticadmin') and !f.acl.write and !f.isCreator(facesContext))}" ajax="false" styleClass="iconbutton" />
							<p:commandButton id="btn_user" action="#{statisticController.toUser(f)}" icon="fa fa-group" value="" title="#{facesContext.translate('button.user')}"
								disabled="#{!profile.hasPrivilege('statisticadmin') and !f.acl.write and !f.isCreator(facesContext)}" ajax="false" styleClass="iconbutton" />
							<ship:removeButton action="#{statisticController.doDelete(f.functionId, f.right)}" value="" tooltip="#{facesContext.translate('tooltip.button.delete')}"
								title="#{facesContext.translate('title.delete.approve')}" approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}"
								disabled="#{f.activated or (!profile.hasPrivilege('statisticadmin') and !f.acl.write and !f.isCreator(facesContext))}">
								<h:outputText value="#{facesContext.translate('confirmation.delete', f.name)}" />
							</ship:removeButton>
							<ui:fragment rendered="#{profile.hasPrivilege('statisticadmin')}">
								<ship:activateButton action="#{statisticController.doSetState(f.functionId, !f.activated, f.name)}" on="#{f.activated}"
									tooltip="#{f.activated ? facesContext.translate('button.deactivate') : facesContext.translate('button.activate')}" title="#{facesContext.translate('title.confirmation')}"
									approveButtonLabel="#{facesContext.translate('button.yes')}" cancelButtonLabel="#{facesContext.translate('button.no')}">
									<h:outputText value="#{facesContext.translate(f.activated ? 'button.confirm.toggleoff' : 'button.confirm.toggleon', f.name)}" />
								</ship:activateButton>
							</ui:fragment>
							<p:menuButton value="" icon="fa fa-download" title="#{facesContext.translate('button.download')}" styleClass="iconbutton"
								rendered="#{profile.hasPrivilege('statisticadmin') || f.acl.write || f.isCreator(facesContext)}">
								<p:menuitem id="btn_download" action="#{statisticController.doDownloadFunction(f.functionId)}" value="#{facesContext.translate('button.download')}" ajax="false" />
								<p:menuitem id="btn_export" action="#{statisticController.doExportFunction(f.functionId)}" value="#{facesContext.translate('button.export.rdata')}" ajax="false" />
							</p:menuButton>
						</ship:buttongroup>
					</p:column>
				</p:dataTable>
			</p:panel>
		</ui:define>
		<ui:define name="formbuttons">
			<p:commandButton id="btn_add" action="#{statisticController.toAdd}" value="#{facesContext.translate('button.statistics.add')}" immediate="true" ajax="false" />
			<p:commandButton id="btn_upload" action="#{statisticController.toUpload}" value="#{facesContext.translate('button.statistics.upload')}" immediate="true" ajax="false" />
      <p:commandButton id="btn_import" action="#{statisticController.toFunctionRegistrator}" value="#{facesContext.translate('button.statistics.functionregistrator')}" immediate="true" ajax="false" rendered="#{profile.hasPrivilege('statisticadmin')}" />
			<p:commandButton id="btn_packages" action="#{statisticController.toPackages}" value="#{facesContext.translate('button.statistics.packages')}" immediate="true" ajax="false" />
			<p:commandButton id="btn_performance" action="#{statisticController.toPerformance}" value="#{facesContext.translate('button.statistics.performance')}" immediate="true" ajax="false"
				onclick="this.form.target='_blank'" onblur="this.form.target='_self'" rendered="false" />
        <!-- deactivated because of the successor of SquareControl2 over squareControl that does not provide that functionality yet -->
		</ui:define>
		<ui:define name="help_de">
    TODO: struckmanns
			Die Liste der vorhandenen R-Funktionen wird dargestellt. Außerdem kann eingesehen werden, welche R-Pakete zur Verfügung stehen und wie die bisherige Verwendung zu werden ist.
		</ui:define>
	</ui:composition>
</h:body>
</html>